<?php
//Protected Resource Endpoint
require_once ("HTTP/OAuth/Provider/Request.php");
require_once ("HTTP/OAuth/Provider/Response.php");
require_once("utils/bdUtils.php");
require_once("utils/ldapUtils.php");

$request = new HTTP_OAuth_Provider_Request;
$verifier = $request['oauth_verifier'];
$token = $request['oauth_token'];
$idclient = $request['oauth_consumer_key'];
$timestamp = $request['oauth_timestamp'];
$scope = $request['scope'];
$nonce = $request['nonce'];
$response = new HTTP_OAuth_Provider_Response;
$tokenSecret = getTempTokenSecret($token);
$clientKey = getClientKey($idclient);
if($clientKey==null){
	error_log("Error al extraer la clave");
	$response->setStatus(HTTP_OAuth_Provider_Response::STATUS_INVALID_SIGNATURE);
	$response->send();
	die(0);

}else{
	if($request->isValidSignature($clientKey, $tokenSecret)){
		$response->setStatus(HTTP_OAuth_Provider_Response::STATUS_INVALID_SIGNATURE);
		$response->send();
		die(0);
	}else{
		$wi = getInfo($token);
		$response->setBody($wi);
		echo json_encode($wi);
	}	
}


function getTempTokenSecret($tempToken){
		$res=null;
		$bd = new liteBD();
		if($bd->existeTempKey($tempToken)){
			$res = $bd->getTempSecret($tempToken);
		}	
	//	$bd->close();
		return $res[0]['tokenSecret'];

}


function getClientKey($name){
		$res=null;
		$bd = new liteBD();
		if($bd->isRegistered($name)){
			$res = $bd->getKeyByName($name);
		}	
		return $res;

}

function getInfo($token){
	$bd = new liteBD();
	$spuc = $bd->getTokenSpuc($token);
	$ldap = new ldap();		
	$res =  $ldap->searchListas($spuc);
//	error_log("WIP:".print_r($res, true));
	return $res;
}

?>