<?php
//Resource Owner Authorization Endpoint
include("utils/papiUtils.php");
require_once ("HTTP/OAuth/Provider/Request.php");
require_once ("HTTP/OAuth/Provider/Response.php");
require_once("utils/bdUtils.php");
require_once("utils/ldapUtils.php");
require_once("utils/criptoUtils.php");

$u = $_SESSION['userdata'];
$req = unserialize($_SESSION['request']);
// Check signature from client cred secret
$token = $req->oauth_token;
$clientKey = getClientKey(getClientName($token));
$response = new HTTP_OAuth_Provider_Response;
//error_log(print_r($u, true));
$spuc = $u['uid'];

if($clientKey==null){
	error_log("Error al extraer la clave");
	die(0);
}
$tokenSecret = getTempTokenSecret($token);
if(!isset($_POST['grant'])){
	error_log("error unknown en roa endpoint logc");
	die(0);
}else{
	$t = $_POST['grant'];
	if(strcmp($t,"No")==0){
		header("Location: ".getCallback($token));
		die(0);
	}else{
		$verifier = authorizeTokenCredentials($token, $spuc);		
		header("Location:".getCallback($token)."?oauth_token=".$token."&oauth_verifier=".$verifier."&oauth_token_secret=".$tokenSecret);
	}
}


function getCallback($token){
	$bd = new liteBD();
	return $bd->getCallback($token);
}


function authorizeTokenCredentials($token, $spuc){	
		$bd = new liteBD();
		$res = rand_str(14);
		$bd->setTempCredAuthorized($token);
		$bd->setTempCredVerifier($token, $res);
		$bd->setTempTokenSpuc($token, $spuc);
		return $res;
}

//Devuelve el nombre del cliente dado un token
function getClientName($token){
	$res=null;
	$bd = new liteBD();
	if($bd->existeTempKey($token)){
		$res = $bd->getClientNameByToken($token);
	}	
	return $res;
}

//Devuelve la clave del cliente	
function getClientKey($name){
		$res=null;
		$bd = new liteBD();
		if($bd->isRegistered($name)){
			$res = $bd->getKeyByName($name);
		}	
		return $res;

}

function getTempTokenSecret($tempToken){
		$res=null;
		$bd = new liteBD();
		if($bd->existeTempKey($tempToken)){
			$res = $bd->getTempSecret($tempToken);
		}	
		return $res;

}


?>