<?php
//Token Request Endpoint
require_once ("HTTP/OAuth/Provider/Request.php");
require_once ("HTTP/OAuth/Provider/Response.php");
require_once("utils/bdUtils.php");
require_once("utils/ldapUtils.php");
require_once("utils/criptoUtils.php");

$request = new HTTP_OAuth_Provider_Request;

$verifier = $request['oauth_verifier'];
$token = $request['oauth_token'];
$idclient = $request['oauth_consumer_key'];
$timestamp = $request['oauth_timestamp'];
$scope = $request['scope'];
$nonce = $request['nonce'];
$timeToken = $request['timeToken'];

$tokenSecret = getTempTokenSecret($token);
$clientKey = getClientKey($idclient);
if($clientKey==null){
	error_log("Error al extraer la clave");
	die(0);
}else{
	$response = new HTTP_OAuth_Provider_Response;	
	if($request->isValidSignature($clientKey, $tokenSecret)){
		$response->setStatus(HTTP_OAuth_Provider_Response::STATUS_INVALID_SIGNATURE);
		$response->send();
		die(0);
	}
	
	
	if(!isAuthorizedRequestToken($token)){
		$response->setStatus(HTTP_OAuth_Provider_Response__STATUS_INVALID_TOKEN);
		$response->send();
		die(0);
	}
	
	if(!isValidVerifier($token, $verifier)){
		echo "ERROR verifier";
	}else{
		$tokenCredentials = assignTokenCredentials($idclient, $token, $timestamp, $scope, $verifier, $timeToken);
		$response->oauth_token = $tokenCredentials['token'];
		$response->oauth_token_secret =  $tokenCredentials['secret'];
		$response->send();
	}
}

/**************************************************/


function isAuthorizedRequestToken($token){
	$bd = new liteBD();
	$res = $bd->isAuthorized($token);
	return $res;
}


function assignTokenCredentials($name, $token, $timestamp, $scope, $verifier, $timeToken){
		$bd = new liteBD();
		$res = array();
		$personSpuc= $bd->getTempTokenSpuc($token);
		$res['token'] = generateTokenKey();
		$res['secret'] = rand_str();
                $timestamp += $timeToken;
		$bd->storeTokenCredential($res['token'], $res['secret'], $name, $personSpuc, $timestamp, $scope, $verifier);
		return $res;
}

function isValidVerifier($token, $verifier){	
	$res=null;
	$bd = new liteBD();
	if($bd->existeTempKey($token)){
		$v = $bd->getTempCredVerifier($token);
		$res = (strcmp($v, $verifier) == 0);
	}
	//error_log("Verifier: ".$res);
	return $res;
	
}


//Devuelve el nombre del cliente dado un token
function getClientName($token){
	$res=null;
	$bd = new liteBD();
	if($bd->existeTempKey($token)){
		$res = $bd->getClientNameByToken($token);
	}	
	return $res;
}


function getClientKey($name){
	$res=null;
	$bd = new liteBD();
	if($bd->isRegistered($name)){
		$res = $bd->getKeyByName($name);
	}	
	return $res;
	
}




function getTempTokenSecret($tempToken){
		$res=null;
		$bd = new liteBD();
		if($bd->existeTempKey($tempToken)){
			$res = $bd->getTempSecret($tempToken);
		}	
	//	$bd->close();
		return $res;

}



?>
